package io.ars.profiling;

import salsa.language.Message;

import java.util.Hashtable;
import java.util.Vector;

//import io.core.agents.AgentFactory;
import io.core.agents.ProfilingAgent;

public class ARSProfilingAgent implements ProfilingAgent {

	private Hashtable actorProfiles = new Hashtable();
	private long totalProcessed = 0;

	// why return 100?
	// supposed to be cycles/s (The processing value)
	public double getProcessing() 		{ return 100; }
	public long processed()			{ return totalProcessed; }

	public Vector getActorProfiles() 	{ return new Vector(actorProfiles.values()); }

	int maxMailboxSize = 0;
	int currentMailboxSize = 0;

	public ARSProfilingAgent() {}

	public void beginProcessed(String identifier) {
		totalProcessed++;

		ActorProfile target = (ActorProfile)actorProfiles.get(identifier);
		if (target == null) return;  
    
		target.processedMessage();
	}
	public void endProcessed(String identifier) { currentMailboxSize--; }

	public void received(String identifier, Message message) {
		ActorProfile target = (ActorProfile)actorProfiles.get(identifier);
		if (target == null) return;

		target.incrementReceived( message.getTarget().ual.getLocation() );

		currentMailboxSize++;
		if (currentMailboxSize > maxMailboxSize) maxMailboxSize = currentMailboxSize;
	}

	public void beginSend(String identifier, Message message) {
		ActorProfile target = (ActorProfile)actorProfiles.get(identifier);
		if (target == null) return;    		
		target.incrementSent( message.getTarget().ual.getLocation() );
	}
	public void endSend(String identifier, Message message) { }

	/*
		The following create new actor profiles and manage their
		entering and exiting the theater
	*/
	public void actorEnter(String identifier) 	{ actorProfiles.put(identifier, new ActorProfile(identifier)); }
	public void actorExit(String identifier) 	{ actorProfiles.remove(identifier); }
	public void updateIdentifier(String uanId, String ualId) {
		ActorProfile target = (ActorProfile)actorProfiles.get(ualId);
		actorProfiles.remove(ualId);
		actorProfiles.put(uanId, target);
	}

	public void reset() {
		totalProcessed = 0;
		maxMailboxSize = 0;
		currentMailboxSize = 0;

		Vector profiles = getActorProfiles();
		for (int i = 0; i < profiles.size(); i++) { ((ActorProfile)profiles.get(i)).reset(); }
	}

	public boolean isLight() {
		return (currentMailboxSize <= maxMailboxSize);
	}
}
