/**
	TheaterLocation:

	Author: Travis Desell
 */

package io.core.protocol;

import java.net.URL;

public class TheaterLocator extends IOPacket implements java.io.Serializable {
	protected java.net.URL url;
	protected java.lang.String protocol;

	public TheaterLocator(TheaterLocator theaterLocator) {

		url = theaterLocator.url;
		protocol = theaterLocator.protocol;
	}

	public TheaterLocator(String theaterName) {
		try {
			protocol = "rmsp";
			int colonPosition = theaterName.indexOf(':');
			if ( ! (protocol.equals( theaterName.substring(0, colonPosition))))
				throw new Exception();

			if (theaterName.indexOf('/',colonPosition+3) > -1) {
				url = new URL("http"+ theaterName.substring(colonPosition, theaterName.indexOf('/',colonPosition+3)));
			} else {
				url = new URL("http"+ theaterName.substring(colonPosition));
			}
		} catch (Exception e) {
			System.err.println("Malformed TheaterLocation : "+theaterName); 
		}
	}

	public boolean equals(TheaterLocator theaterLocator) {
		return this.toString().equals(theaterLocator.toString());
	}

	public int getPort() {
		return url.getPort();
	}

	public String getProtocol() {
		return this.protocol;
	}

	public String getHost() {
		return url.getHost();
	}

	public String toString() {
		String urlString = url.toString();

		return this.protocol + urlString.substring(urlString.indexOf(':'));
	}
}
