/* Generated by Salsa Compiler v0.5 */



package io.testing.benchmarks;
import java.io.FileInputStream;

import java.util.Vector;

import java.util.Random;

import java.util.StringTokenizer;


import java.io.IOException;
import salsa.language.*;
import salsa.language.exceptions.*;
import salsa.resources.*;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.exceptions.*;

public class Hypercube extends ActorReference {
	public Hypercube selfReference;

	public class State extends Actor {
		protected Hypercube self;
		int messageSendingDelay;
		int messageSize;
		int processingTime;
		String nameServer;
		Vector theaters;
		Random seed = new Random(5);
		Node[] nodes;
		int size;
		int length;
		int width;
		int height;

		public void printTheaters(int counter) {
			if (counter<theaters.size()) {
				{
					ActorReference[] _targets = { self, null };
					String[] _methodNames = { "printTheaters", null };
					Object[][] _arguments = { {new Integer(counter+1)}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					self.send(_continuation);
				}
			}
			else  {
				{
					ActorReference[] _targets = { standardOutput, null };
					String[] _methodNames = { "print", null };
					Object[][] _arguments = { {""}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					standardOutput.send(_continuation);
				}
			}
			//Dummy return value, because currentContinuation was used in this block
			currentContinuation = null;
			return;
		}


		public void generateNodes() {
			nodes=new Node[(int )size];
			
			for (int i = 0;i<size;i++) {
				nodes[i]=new Node(messageSendingDelay, messageSize, processingTime);
			}
		}


		public void generateLinks() {
			
			for (int i = 0;i<size;i++) {
				if ((i+1)<size){
					ActorReference[] _targets = { nodes[i] };
					String[] _methodNames = { "addReference" };
					Object[][] _arguments = { {nodes[i+1]} };

					nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
;
				if ((i-1)>=0){
					ActorReference[] _targets = { nodes[i] };
					String[] _methodNames = { "addReference" };
					Object[][] _arguments = { {nodes[i-1]} };

					nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
;
				if ((i+length)<size){
					ActorReference[] _targets = { nodes[i] };
					String[] _methodNames = { "addReference" };
					Object[][] _arguments = { {nodes[i+length]} };

					nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
;
				if ((i-length)>=0){
					ActorReference[] _targets = { nodes[i] };
					String[] _methodNames = { "addReference" };
					Object[][] _arguments = { {nodes[i-length]} };

					nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
;
				if ((i+(length*width))<size){
					ActorReference[] _targets = { nodes[i] };
					String[] _methodNames = { "addReference" };
					Object[][] _arguments = { {nodes[i+(length*width)]} };

					nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
;
				if ((i-(length*width))>=0){
					ActorReference[] _targets = { nodes[i] };
					String[] _methodNames = { "addReference" };
					Object[][] _arguments = { {nodes[i-(length*width)]} };

					nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
;
			}
		}


		public void bindActors(int i, int theaterNum) {
			if (i<size) {
				if (theaterNum>=theaters.size())theaterNum=0;
				{
					ActorReference[] _targets = { self, nodes[i], null };
					String[] _methodNames = { "bindActors", "bind", null };
					Object[][] _arguments = { {new Integer(i+1), new Integer(theaterNum+1)}, {new String(nameServer+"tree_node_"+i), new String((String )theaters.get(theaterNum)+"tree_node_"+i)}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					self.send(_continuation);
				}
			}
			else  {
				{
					ActorReference[] _targets = { standardOutput, null };
					String[] _methodNames = { "print", null };
					Object[][] _arguments = { {""}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					standardOutput.send(_continuation);
				}
			}
			//Dummy return value, because currentContinuation was used in this block
			currentContinuation = null;
			return;
		}


		public void startComputation() {
			
			for (int j = 0;j<size;j++) {
				{
					ActorReference[] _targets = { nodes[j], standardOutput };
					String[] _methodNames = { "startSending", "println" };
					Object[][] _arguments = { {}, {new String("round trip for nodes: "+j)} };

					nodes[j].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
			}
		}


		public void act(String[] arguments) {
			try {
				if (arguments.length!=7) {
					System.err.println("Usage: ");
					System.err.println("\tjava io.testing.benchmarks.Sparse <naming/theater information file> "+"<length> <width> <height> <messageSendingDelay(ms)> <messageSize(bytes)> "+"<processingTime(ms)>");
					System.exit(0);
				}
				theaters=new Vector();
				FileInputStream file;
				byte input[];
				try {
					file=new FileInputStream(arguments[0]);
					input=new byte[file.available()];
					file.read(input);
					StringTokenizer st = new StringTokenizer(new String(input), "\n");
					nameServer=st.nextToken();
					
					while (st.hasMoreTokens()) {
						theaters.add(st.nextToken());
					}
				}
				catch (Exception e) {
					System.err.println("Error reading naming/theater information file: "+e);
					System.exit(0);
				}
				length=new Integer(arguments[1]).intValue();
				width=new Integer(arguments[2]).intValue();
				height=new Integer(arguments[3]).intValue();
				messageSendingDelay=new Integer(arguments[4]).intValue();
				messageSize=new Integer(arguments[5]).intValue();
				processingTime=new Integer(arguments[6]).intValue();
			}
			catch (Exception e) {
				System.err.println("Usage: ");
				System.err.println("\tjava io.testing.benchmarks.Sparse <naming/theater information file> "+"<length> <width> <height> <messageSendingDelay(ms)> <messageSize(bytes)> "+"<processingTime(ms)>");
				System.exit(0);
			}
			size=length*width*height;
			{
				ActorReference[] _targets = { standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, self, standardOutput, standardOutput, self, standardOutput, self, standardOutput, self, standardOutput, self, standardOutput };
				String[] _methodNames = { "println", "println", "println", "println", "println", "println", "println", "println", "println", "println", "println", "println", "printTheaters", "println", "println", "generateNodes", "println", "bindActors", "println", "generateLinks", "println", "startComputation", "println" };
				Object[][] _arguments = { {"Creating a hypercube actor graph with: "}, {"\tnodes in hypercube actor graph: "+size}, {"\t\tlength: "+length}, {"\t\twidth: "+width}, {"\t\theight: "+height}, {"\tdelay between message sends: "+messageSendingDelay+"(ms)"}, {"\tsize of messages: "+messageSize+"(bytes)"}, {"\tprocessing intensity of a message: "+processingTime+"(ms)"}, {}, {"Using name server:"}, {"\t"+nameServer}, {"Loading actor graph randomly on theater(s): "}, {new Integer(0)}, {}, {"Generating nodes..."}, {}, {"Binding actors..."}, {new Integer(0), new Integer(0)}, {"Generating links..."}, {}, {"Starting computation..."}, {}, {"finished."} };

				standardOutput.send( new Message( self, _targets, _methodNames, _arguments ) );
			}
		}

		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}

		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
			start();
		}

		public State() {
			this.self = selfReference;
		}
	}

	public Hypercube() { 
		selfReference = this;
		State state = new State();
		ual = state.__ual;
		ServiceFactory.getTheater().setEntry(ual, state);
	}


	public Hypercube(UAN uan) { super(uan); }

	public Hypercube(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Hypercube _hypercube = new Hypercube();

		{
			ActorReference[] _targets = { _hypercube };
			String[] _methodNames = { "act" };
			Object[][] _arguments = { { args } };

			_hypercube.send( new Message( null, _targets, _methodNames, _arguments ) );
		}

	}
}
