/* Generated by Salsa Compiler v0.5 */



package io.testing.benchmarks;
import java.io.FileInputStream;

import java.util.Vector;

import java.util.StringTokenizer;


import java.io.IOException;
import salsa.language.*;
import salsa.language.exceptions.*;
import salsa.resources.*;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.exceptions.*;

public class Tree extends ActorReference {
	public Tree selfReference;

	public class State extends Actor {
		protected Tree self;
		int messageSendingDelay;
		int messageSize;
		int processingTime;
		String nameServer;
		Vector theaters;
		Node[] nodes;
		int size;
		int width;
		int depth;

		public void printTheaters(int counter) {
			System.out.println("inside printTheaters with counter = "+counter);
			if (counter<theaters.size()) {
				{
					ActorReference[] _targets = { self, standardOutput, null };
					String[] _methodNames = { "printTheaters", "println", null };
					Object[][] _arguments = { {new Integer(counter+1)}, {"\t"+(String )theaters.get(counter)}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					self.send(_continuation);
				}
			}
			else  {
				{
					ActorReference[] _targets = { standardOutput, null };
					String[] _methodNames = { "print", null };
					Object[][] _arguments = { {""}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					standardOutput.send(_continuation);
				}
			}
			//Dummy return value, because currentContinuation was used in this block
			currentContinuation = null;
			return;
		}


		public void generateNodes() {
			nodes=new Node[(int )size];
			
			for (int i = 0;i<size;i++) {
				nodes[i]=new Node(messageSendingDelay, messageSize, processingTime);
			}
		}


		public void generateLinks() {
			
			for (int i = 0;i<size;i++) {
				
				for (int j = 0;j<width;j++) {
					if (((i*width)+j+1)<size) {
						{
							ActorReference[] _targets = { nodes[i] };
							String[] _methodNames = { "addReference" };
							Object[][] _arguments = { {nodes[(i*width)+j+1]} };

							nodes[i].send( new Message( self, _targets, _methodNames, _arguments ) );
						}
;
					}
				}
			}
		}


		public void bindActors(int i, int theaterNum) {
			if (i<size) {
				if (theaterNum>=theaters.size())theaterNum=0;
				{
					ActorReference[] _targets = { self, nodes[i], null };
					String[] _methodNames = { "bindActors", "bind", null };
					Object[][] _arguments = { {new Integer(i+1), new Integer(theaterNum+1)}, {new String(nameServer+"tree_node_"+i), new String((String )theaters.get(theaterNum)+"tree_node_"+i)}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					self.send(_continuation);
				}
			}
			else  {
				{
					ActorReference[] _targets = { standardOutput, null };
					String[] _methodNames = { "print", null };
					Object[][] _arguments = { {""}, { new FirstClassToken() } };

					Message _continuation = new Message( self, _targets, _methodNames, _arguments );
					_continuation.updateFirstClass(currentContinuation);
					standardOutput.send(_continuation);
				}
			}
			//Dummy return value, because currentContinuation was used in this block
			currentContinuation = null;
			return;
		}


		public void startComputation() {
			
			for (int j = 0;j<size;j++) {
				{
					ActorReference[] _targets = { nodes[j], standardOutput };
					String[] _methodNames = { "startSending", "println" };
					Object[][] _arguments = { {}, {new String("round trip for nodes: "+j)} };

					nodes[j].send( new Message( self, _targets, _methodNames, _arguments ) );
				}
			}
		}


		public void act(String[] arguments) {
			try {
				if (arguments.length!=6) {
					System.err.println("Usage: ");
					System.err.println("\tjava io.testing.benchmarks.Tree <naming/theater information file> "+"<width> <depth> <messageSendingDelay(ms)> <messageSize(bytes)> <processingTime(ms)>");
					System.exit(0);
				}
				theaters=new Vector();
				FileInputStream file;
				byte input[];
				try {
					file=new FileInputStream(arguments[0]);
					input=new byte[file.available()];
					file.read(input);
					StringTokenizer st = new StringTokenizer(new String(input), "\n");
					nameServer=st.nextToken();
					
					while (st.hasMoreTokens()) {
						theaters.add(st.nextToken());
					}
				}
				catch (Exception e) {
					System.err.println("Error reading naming/theater information file: "+e);
					System.exit(0);
				}
				depth=new Integer(arguments[1]).intValue();
				width=new Integer(arguments[2]).intValue();
				messageSendingDelay=new Integer(arguments[3]).intValue();
				messageSize=new Integer(arguments[4]).intValue();
				processingTime=new Integer(arguments[5]).intValue();
			}
			catch (Exception e) {
				System.err.println("Usage: ");
				System.err.println("\tjava io.testing.benchmarks.Tree <naming/theater information file> "+"<width> <depth> <messageSendingDelay(ms)> <messageSize(bytes)> <processingTime(ms)>");
				System.exit(0);
			}
			if (depth==0) {
				size=1;
			}
			else if (depth==1) {
				size=1+width;
			}
			else  {
				size=(int )java.lang.Math.round(java.lang.Math.pow(width, depth-1))+(int )java.lang.Math.round((java.lang.Math.pow(width, depth-1)-1))/(width-1);
			}
			{
				ActorReference[] _targets = { standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, standardOutput, self, standardOutput, standardOutput, self, standardOutput, self, standardOutput, self, standardOutput, self, standardOutput };
				String[] _methodNames = { "println", "println", "println", "println", "println", "println", "println", "println", "println", "println", "println", "printTheaters", "println", "println", "generateNodes", "println", "bindActors", "println", "generateLinks", "println", "startComputation", "println" };
				Object[][] _arguments = { {"Creating a tree actor graph with: "}, {"\tnodes in tree actor graph: "+size}, {"\tdepth of tree actor graph: "+depth}, {"\twidth of tree actor graph: "+width}, {"\tsize of messages: "+messageSize+"(bytes)"}, {"\tdelay between message sends: "+messageSendingDelay+"(ms)"}, {"\tprocessing intensity of a message: "+processingTime+"(ms)"}, {}, {"Using name server:"}, {"\t"+nameServer}, {"Loading actor graph randomly on theater(s): "}, {new Integer(0)}, {}, {"Generating nodes..."}, {}, {"Binding actors..."}, {new Integer(0), new Integer(0)}, {"Generating links..."}, {}, {"Starting computation..."}, {}, {"finished."} };

				standardOutput.send( new Message( self, _targets, _methodNames, _arguments ) );
			}
		}

		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}

		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
			start();
		}

		public State() {
			this.self = selfReference;
		}
	}

	public Tree() { 
		selfReference = this;
		State state = new State();
		ual = state.__ual;
		ServiceFactory.getTheater().setEntry(ual, state);
	}


	public Tree(UAN uan) { super(uan); }

	public Tree(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Tree _tree = new Tree();

		{
			ActorReference[] _targets = { _tree };
			String[] _methodNames = { "act" };
			Object[][] _arguments = { { args } };

			_tree.send( new Message( null, _targets, _methodNames, _arguments ) );
		}

	}
}
